<?php
/**
 * @package		Joomla.Site
 * @subpackage	mod_users_latest
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */
// no direct access
defined('_JEXEC') or die;

$app   = JFactory::getApplication();
$db	   = JFactory::getDbo();
$user  = JFactory::getUser();
$query = $db->getQuery(true);
$query
	->select('a.id, a.name, a.username, a.registerDate')
	->from('#__users AS a')
	->where('a.block = 0')
	->where('(a.activation is null or a.activation = "")')
	->order('a.registerDate DESC');

if (!$user->authorise('core.admin') && $params->get('filter_groups', 0) == 1)
{
	$groups = $user->getAuthorisedGroups();
	if (empty($groups))
	{
		return array();
	}
	$query
		->leftJoin('#__user_usergroup_map AS m ON m.user_id = a.id')
		->leftJoin('#__usergroups AS ug ON ug.id = m.group_id')
		->where('ug.id in (' . implode(',', $groups) . ')')
		->where('ug.id <> 1');
}

$db->setQuery($query, 0, $params->get('shownumber'));
$names = $db->loadObjectList();

?>
<?php if(!empty($names)) : ?>
	<?php
		// Get contact id
		$uids  = array_map(create_function('$u', ' return $u->id; '), $names);

		$query = $db->getQuery(true);
		$query->select('*');
		$query->from('#__contact_details AS contact');
		$query->where('contact.published = 1');
		$query->where('contact.user_id in (' . implode(',', $uids) . ')');

		// Filter by language
		if ($app->getLanguageFilter())
		{
			$query->where('(contact.language in (' . $db->quote(JFactory::getLanguage()->getTag()) . ',' . $db->quote('*') . ') OR contact.language IS NULL)');
		}

		$db->setQuery($query);
		$contacts = $db->loadObjectList('user_id');

		$tplparams = JFactory::getApplication()->getTemplate(true)->params;

	?>
	
	<ul class="latestusers<?php echo $moduleclass_sfx ?>">
	<?php foreach($names as $name) : ?>
		<li>
			<?php if(isset($contacts[$name->id])) : ?>
				<?php 
					$contact   = $contacts[$name->id];
					$addparams = $tplparams->get('tpl_userpage_mid') ? '&Itemid=' . $tplparams->get('tpl_userpage_mid') : '';
					$link      = JRoute::_('index.php?option=com_contact&view=contact' . $addparams . '&id='.$contact->id);
				?>
				<div class="avatar">
					<a href="<?php echo $link ?>">
						<?php if(!empty($contact->image)) : ?>
						<img src="<?php echo htmlspecialchars($contact->image) ?>" alt="<?php echo $contact->name ?>" />
						<?php else: ?>
						<i class="no-avatar icon-user"></i>
						<?php endif ?>
					</a>
				</div>
				<span class="name"><a href="<?php echo $link ?>"><?php echo $contact->name ?></a></span>
				<div class="contact-desc"><?php echo $contact->misc; ?></div>
			<?php else :?>
				<div class="avatar">
					<i class="no-avatar icon-user"></i>
				</div>
				<span class="name"><?php echo $name->name ?></span>
			<?php endif ?>
		</li>
	<?php endforeach;  ?>
	</ul>

<?php endif ?>