<?php
/** 
 *------------------------------------------------------------------------------
 * @package       T3 Framework for Joomla!
 *------------------------------------------------------------------------------
 * @copyright     Copyright (C) 2004-2013 JoomlArt.com. All Rights Reserved.
 * @license       GNU General Public License version 2 or later; see LICENSE.txt
 * @authors       JoomlArt, JoomlaBamboo, (contribute to this project at github 
 *                & Google group to become co-author)
 * @Google group: https://groups.google.com/forum/#!forum/t3fw
 * @Link:         http://t3-framework.org 
 *------------------------------------------------------------------------------
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * T3 Blank Helper class
 *
 * @package		T3 Blank
 */


jimport('joomla.event.event');

class JA_MagzHook extends JEvent
{
	
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);		
	}
	
	public function onT3Init() // no params
	{
		//load renderer
		if(!class_exists('JDocumentRendererMegamenu', false)){
			include_once(T3_TEMPLATE_PATH . '/etc/renderer/megamenu.php');
		}

		//overwrite userpage routing layout
		$input     = JFactory::getApplication()->input;
		$tplparams = JFactory::getApplication()->getTemplate(true)->params;

		if($input->get('option') == 'com_contact' && $input->get('view') == 'contact' && $input->get('Itemid') == $tplparams->get('tpl_userpage_mid')){
			$params = JComponentHelper::getParams('com_contact');
			$params->set('contact_layout', T3_TEMPLATE . ':userpage');	
		}

	}

	public function onT3BodyClass(&$class)
	{
		$input = JFactory::getApplication()->input;
		if($input->get('option') == 'com_content' && $input->get('view') == 'article' && in_array($input->get('extype'), array('video', 'gallery'))){
			$class[] = 'media-page';			
		}

		if(T3::getApp()->getParam('responsive', 1) == 0){
			$class[] = 'no-respon';
		}
	}
}
?>