<?php
/**
 * @package   T3 Blank
 * @copyright Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license   GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;
?>

<!-- FOOTER -->
<footer id="t3-footer" class="wrap t3-footer">

  <!-- FOOT NAVIGATION -->
  <?php if ($this->checkSpotlight('footnav', 'footer-1, footer-2, footer-3, footer-4, footer-5, footer-6')) : ?>
    <div class="container t3-sl spl-home-5">
      <?php 
        $this->spotlight ('footnav', 'footer-1, footer-2, footer-3, footer-4, footer-5, footer-6', array(
          'footer-1' => array(
              'tablet' => 'span4',
              'xtablet' => 'span4'
            ),
          'footer-2' => array(
              'tablet' => 'span4',
              'xtablet' => 'span4'
            ),
          'footer-3' => array(
              'tablet' => 'span4',
              'xtablet' => 'span4'
            ),
          'footer-4' => array(
              'tablet' => 'span4 spanfirst',
              'xtablet' => 'span4 spanfirst'
            ),
          'footer-5' => array(
              'tablet' => 'span4',
              'xtablet' => 'span4'
            ),
          'footer-6' => array(
              'tablet' => 'span4',
              'xtablet' => 'span4'
            )
        )) 
      ?>
    </div>
  <?php endif; ?>
  <!-- //FOOT NAVIGATION -->

  <section class="t3-copyright">
    <div class="container">
      <div class="row">
        <?php
          $hasFooterLogo   = $this->countModules('footer-logo');
          $hasFooterSocial = $this->countModules('footer-social');
          $hasFooter       = $this->countModules('footer');
          $hasT3Logo       = $this->getParam('t3-rmvlogo', 1);
        ?>

        <?php if($hasFooterLogo): ?>        
        <div class="<?php echo ($hasT3Logo || $hasFooterSocial || $hasFooter) ? 'span4' : 'span12' ?> footer-logo <?php $this->_c('footer-logo')?>">
          <jdoc:include type="modules" name="<?php $this->_p('footer-logo') ?>" />
        </div>
        <?php endif; ?>

        <?php if($hasT3Logo || $hasFooterSocial || $hasFooter): ?>
        <div class="<?php echo $hasFooterLogo ? 'span8 pull-right' : 'span12' ?>">
          <?php if($hasFooterSocial): ?>
          <div class="footer-social clearfix <?php $this->_c('footer-social')?>">
            <jdoc:include type="modules" name="<?php $this->_p('footer-social') ?>" />
          </div>
          <?php endif; ?>

          <?php if($hasFooter): ?>
          <div class="copyright <?php $this->_c('footer')?>">
            <jdoc:include type="modules" name="<?php $this->_p('footer') ?>" />
          </div>
          <?php endif; ?>

          <?php if($hasT3Logo): ?>
          <div class="poweredby">
            <a class="t3-logo t3-logo-dark" href="http://t3-framework.org" title="Powered By T3 Framework" target="_blank" rel="nofollow">Powered by <strong>T3 Framework</strong></a>
          </div>
          <?php endif; ?>
        </div>
        <?php endif; ?>

      </div>
    </div>
  </section>

</footer>
<!-- //FOOTER -->

<!-- BACK TO TOP -->
<div id="back-to-top" class="back-to-top t3-hide">
  <i class="icon-long-arrow-up"></i>
</div>
<script type="text/javascript">
  //<![CDATA[
  (function($){
    $(document).ready(function(){
      $('#back-to-top').click(function(){
        if($(this).hasClass('reveal')){
          $('html, body').stop(true).animate({
            scrollTop: 0
          });
        }
      });

      $(window).scroll(function(){
        $('#back-to-top').toggleClass('reveal', $(window).scrollTop() > (Math.min($('#t3-mainbody').length ? $('#t3-mainbody').offset().top : 0, 150)));
      });
    });
  })(jQuery);
  //]]>
</script>
<!-- //BACK TO TOP -->
